; Mr. Gimmick (Europe)
; NSF ripped by rainwarrior 5/18/2012

;
; NSF Header
;
.segment "HEADER"
;
.byte 'N', 'E', 'S', 'M', $1A ; ID
.byte $01 ; version
.byte 106 ; songs
.byte 1 ; starting song
.word $8000 ; load address
.word nsf_init ; init function
.word nsf_play ; play function
; title
.byte "Mr. Gimmick (Europe)"
.byte         0,0,0,0,0,0,0,0,0,0,0,0
; artist
.byte "Masashi Kageyama,Naohisa Morota"
.byte                               0
; copyright
.byte "1992 Sunsoft",         0,0,0,0
.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
; other
.word 20000 ; NTSC speed
.byte 0,1,2,3,4,5,6,7 ; bankswitch init
.word 20000 ; PAL speed
.byte $01 ; PAL/NTSC bits
.byte $00 ; expansion bits
.byte 0,0,0,0 ; pad to $80

;
; NSF Body
;


nsf_play = $EA92

; music playback code
.segment "CODE_8000"
;.incbin "07_8000.prg" ; have disassembled and edited this
.scope
.include "07_8000.s"
.endscope


; music data (bankswitched)
.segment "CODE_A000"
; filled with an outlying bank
.incbin "00_A000.prg"


; DPCM segment (is set up by bankswitching)
.segment "CODE_C000"
; filled with an outlying bank
.incbin "18_A000.prg" ; Sophia, Good Morning, Good Night


.segment "CODE_E000"
;.incbin "1F_E000_edit.prg"
.scope
.include "1F_E000.s"
.endscope

; init routine and bankswitching,
; these actually bankswitch and branch to an extra code bank at 8000
; because there was not enough empty space in this bank
nsf_init:
	PHA
	JSR $8000 ; main init
	PLA
	JSR extra_8000
	JSR extra_song_init
	JSR restore_8000
	JSR $8006 ; song init
	RTS
bank_A000: ; bankswitching for A000 (Music data)
bank_C000: ; bankswitching for C000 (DPCM)
	; had to combine these to save space; disambiguate by which bank is requested
	JSR extra_8000
	JSR extra_bankswitch
	JSR restore_8000
	RTS
extra_8000: ; temporarily swap out $8000 for custom code (couldn't find room)
	PHA
	LDA #$18
	STA $5FF8
	LDA #$19
	STA $5FF9
	PLA
	RTS
restore_8000: ; return to our regularly scheduled program at $8000
	PHA
	LDA #$00
	STA $5FF8
	LDA #$01
	STA $5FF9
	PLA
	RTS

.segment "CODE_BANKS0" ; music data
.incbin "08_A000.prg" ; Lion Heart, Strange Memory of Death, Slow Illusion
.incbin "09_A000.prg" ; Good Weather, Paradigm, Cadbury
.incbin "0A_A000.prg" ; Happy Birthday, Aporia, Siesta
.incbin "0B_A000.prg" ; Just Friends, Identity, Paradox, Innocent, Long Tomorrow

.segment "CODE_BANKS1" ; DPCM banks
.incbin "0C_C000.prg"
.incbin "0D_C000.prg"
.incbin "0E_C000.prg"
.incbin "0F_C000.prg"

.segment "CODE_BANKS2" ; bank for facilitating INIT and bankswitch tables

extra_song_init:
	TAX
	LDA extra_song_table, X
	RTS

extra_song_table:
; songs
.byte   0 ;   1 Lion Heart
.byte   1 ;   2 Strange Memories of Death (unused?)
.byte   2 ;   3 Slow Illusion
.byte   3 ;   4 Good Weather
.byte   4 ;   5 Paradigm
.byte   5 ;   6 Cadbury
.byte   6 ;   7 Happy Birthday
.byte   7 ;   8 Just Friends
.byte   8 ;   9 Aporia
.byte   9 ;  10 Identiy Believer
.byte  11 ;  11 Paradox
.byte  12 ;  12 Innocent
.byte  26 ;  13 Long Tomorrow
.byte  43 ;  14 Final Boss Part 1 (not in sound test)
.byte  44 ;  15 No Limits
.byte  60 ;  16 Sophia (Take 2)
.byte  61 ;  17 Good Morning
.byte  62 ;  18 Good Night (Take 2)
.byte  67 ;  19 Siesta
; 10 is Cadbury
; 63 is Sophia (Take 2)
; SFX
.byte  14
.byte  15,  16,  17,  18,  19,  20,  21,  22,  23,  24 ; 30
.byte  25,  27,  28,  29,  30,  32,  33,  34,  35,  36 ; 40
.byte  37,  38,  39,  40,  41,  42,  45,  46,  47,  48 ; 50
.byte  49,  50,  51,  52,  53,  54,  55,  56,  57,  58 ; 60
.byte  59,  64,  65,  66,  68,  69,  70,  71,  72,  73 ; 70
.byte  74,  75,  76,  77,  78,  80,  81,  82,  83,  84 ; 80
.byte  85,  86,  87,  88,  89,  90,  91,  92,  93,  94 ; 90
.byte  95,  96,  97,  98,  99, 100, 101, 102, 103, 104 ; 100
.byte 105, 106, 107, 108, 109, 110
; padding (makes it easy to find end when testing)
.byte 0

extra_bankswitch:
	PHA
	STX $00 ; hope this variable is okay, need to preserve X
	TAX
	LDA extra_bank_table, X
	ASL
	PHA
	LDA extra_bank_type, X
	BMI @dpcm_bank
@music_bank:
	PLA
	STA $5FFA
	CLC
	ADC #1
	STA $5FFB
	JMP @done
@dpcm_bank:
	PLA
	STA $5FFC
	CLC
	ADC #1
	STA $5FFD
	JMP @done
@done:
	LDX $00
	PLA
	RTS

; bank table maps $8k maps in Mr. Gimmick ROM to this NSF
; (not included banks are stored in the table as $00)
extra_bank_table:
;     $00, $01, $02, $03, $04, $05, $06, $07
.byte $01, $FF, $FF, $FF, $FF, $FF, $FF, $00
;     $08, $09, $0A, $0B, $0C, $0D, $0E, $0F
.byte $04, $05, $06, $07, $08, $09, $0A, $0B ; BANKS0, BANKS1
;     $10, $11, $12, $13, $14, $15, $16, $17
.byte $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
;     $18, $19, $1A, $1B, $1C, $1D, $1E, $1F
.byte $02, $FF, $FF, $FF, $FF, $FF, $FF, $03

extra_bank_type: ; disambiguates which banks go to A000 or C000
;     $00, $01, $02, $03, $04, $05, $06, $07
.byte $00, $00, $00, $00, $00, $00, $00, $00
;     $08, $09, $0A, $0B, $0C, $0D, $0E, $0F
.byte $00, $00, $00, $00, $FF, $FF, $FF, $FF
;     $10, $11, $12, $13, $14, $15, $16, $17
.byte $00, $00, $00, $00, $00, $00, $00, $00
;     $18, $19, $1A, $1B, $1C, $1D, $1E, $1F
.byte $00, $00, $00, $00, $00, $00, $00, $00

.byte " === This NSF was ripped by rainwarrior, 5/18/2012."
.byte " 8k banks used from gimmick as follows:"
.byte " 07 00 18 1F 08 09 0A 0B 0C 0D 0E 0F."

.byte " Bank 07 was modified at 0115, 0265, and 0E76,"
.byte " replacing STA $A000 (FME-7 bankswitch) with JSR to NSF bankswitch routine."

.byte " An RTS was inserted at 0EAE in bank 17 to turn the NTSC->PAL speed conversion"
.byte " routine into a subroutine I could use as PLAY. (The music data is internally"
.byte " at NTSC speed, but it is converted by calling the music update routine at $8009"
.byte " twice on every 5th frame."

.byte " Code was insertedin the last 60 bytes of bank 1F for INIT and bankswitch"
.byte " (this region was not used for music playback)."

.byte " More extra code was placed in an additional bank at the end of the NSF file,"
.byte " which is switched into $8000 temporarily as needed."

.byte " No other modifications were made to the original banks."

;
; End of file
;
